package bogusmessage;

import java.io.IOException;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import application.Status;


import rice.p2p.commonapi.Id;
import rice.p2p.commonapi.Message;
import rice.p2p.commonapi.rawserialization.*;
import winterwell.jtwitter.Twitter;

//The bogus server "getUser" msg type, never used in communication
//Used in counting the traffic
public class ServerGetStatusesMsg implements RawMessage {
	private static final long serialVersionUID = 201007232214L;
	// For the bogus msg type
	public static final short TYPE = -1;
	
	private List<Status> statuses;
	
	// Where the Message came from
    private Id from;
    private String fromUserId;
	
	public ServerGetStatusesMsg(List<Twitter.Status> i, Id f, String fid) {
		statuses = transStatuses(i);
		from = f;
		fromUserId = fid;
	}
	
	private static List<Status> transStatuses(List<Twitter.Status> ts) {
		List<Status> ll = new ArrayList<Status>();
		Iterator<Twitter.Status> iterator = ts.iterator();
		while(iterator.hasNext()) {
			ll.add(new Status(iterator.next()));
		}
		return ll;
	}

	public short getType() {
		return TYPE;
	}

	public int getPriority() {
		return Message.LOW_PRIORITY;
	}

	public void serialize(OutputBuffer arg0) throws IOException {
		// Just a bogus one
	}
	
	public Id getFrom() {
		return from;
	}
	
	public String getFromUserId() {
		return fromUserId;
	}
	
	public List<Status> getStatuses() {
		return statuses;
	}
}
