package infrastructure;

import message.CuckooMsg;
import message.DirectUpdateStatusMsg;
import message.GossipUpdateStatusMsg;
import message.ReqNodeHandleMsg;

import org.mpisws.p2p.transport.exception.NodeIsFaultyException;

import application.Cuckoo;
import application.Status;

import rice.p2p.commonapi.DeliveryNotification;
import rice.p2p.commonapi.MessageReceipt;
import toolbox.Mailbox;

//To know the send failure of directRoute
public class DirectDeliveryNotification implements DeliveryNotification{
	//private Exception exception;
	private Mailbox mailbox;
	private Status status;
	private String userId;
	private Cuckoo cuckoo;
	private CuckooMsg msg;
	
	public DirectDeliveryNotification(Mailbox mb, Status s, String uid, Cuckoo cuc, CuckooMsg mg) {
		mailbox = mb;
		status  = s;
		userId  = uid;
		cuckoo = cuc;
		msg = mg;
	}
	
	public void sendFailed(MessageReceipt arg0, Exception arg1) {
		System.out.println("get into the sendFailed() function");
		
		if(arg1 instanceof NodeIsFaultyException) {
			mailbox.add2mailbox(userId, status);
		}
		//mailbox.printMailbox();
		
		cuckoo.reroute(Cuckoo.getIdFromString(userId), new ReqNodeHandleMsg(msg.getFrom(), msg.getTo(), msg.getFromUserId(), msg.getToUserId(), cuckoo.getNodeHandle(), cuckoo.getBloomFilter()), null);
		
		if(msg instanceof DirectUpdateStatusMsg) {
			cuckoo.decreaseFollowerHealth(msg.getToUserId());
		} else if(msg instanceof GossipUpdateStatusMsg) {
			if(msg.getFromUserId().compareTo(status.getAuthorId()) == 0) {
				cuckoo.decreaseFollowerHealth(msg.getToUserId());
			} else {
				cuckoo.decreasePartnerHealth(status.getAuthorId(), msg.getToUserId());
			}
		}
	}

	public void sent(MessageReceipt arg0) {
		System.out.println(arg0);
		
		if(msg instanceof GossipUpdateStatusMsg) {
			cuckoo.increaseGossipSent(((GossipUpdateStatusMsg) msg).getStatusId());
			
			if(msg.getFromUserId().compareTo(status.getAuthorId()) == 0) {
				cuckoo.increaseFollowerHealth(msg.getToUserId());
			} else {
				cuckoo.increasePartnerHealth(status.getAuthorId(), msg.getToUserId());
			}
		} else if(msg instanceof DirectUpdateStatusMsg) {
			cuckoo.increaseFollowerHealth(msg.getToUserId());
		}
	}
}
