package message;

import java.io.IOException;

import rice.p2p.commonapi.Endpoint;
import rice.p2p.commonapi.Id;
import rice.p2p.commonapi.NodeHandle;
import rice.p2p.commonapi.rawserialization.InputBuffer;
import rice.p2p.commonapi.rawserialization.OutputBuffer;
import rice.p2p.util.BloomFilter;

public class RplNodeHandleErrMsg extends CuckooPiggybackMsg {
	private static final long serialVersionUID = 201007191754L;
	public static final short TYPE = 9;
    
    private String originUserId;

    // Constructor.
    public RplNodeHandleErrMsg(Id from, Id to, String fid, String tid, NodeHandle nh, BloomFilter bf, String originId) {
    	super(from, to, fid, tid, nh, bf);
    	this.originUserId = originId;
    }

	public short getType() {
		return TYPE;
	}
	
	public void serialize(OutputBuffer buf) throws IOException {
		super.serialize(buf);
	    buf.writeUTF(originUserId);
	}
	
	public RplNodeHandleErrMsg(InputBuffer buf, Endpoint endpoint) throws IOException {
		super(buf, endpoint);
	    originUserId = buf.readUTF();
	}
	
	public String getOriginId() {
		return originUserId;
	}
}
