package message;

import java.io.IOException;

import rice.p2p.commonapi.Endpoint;
import rice.p2p.commonapi.Id;
import rice.p2p.commonapi.NodeHandle;
import rice.p2p.commonapi.rawserialization.InputBuffer;
import rice.p2p.commonapi.rawserialization.OutputBuffer;
import rice.p2p.util.BloomFilter;

public class RplStatusErrMsg extends CuckooPiggybackMsg {
	private static final long serialVersionUID = 201004201510L;
	public static final short TYPE = 13;
    
    private String userId;
    
    // Constructors.
    public RplStatusErrMsg(Id from, Id to, String fid, String tid, NodeHandle nh, BloomFilter bf, String userId) {
    	super(from, to, fid, tid, nh, bf);
    	this.userId = userId;
    }
	
	public short getType() {
		return TYPE;
	}
	
	public void serialize(OutputBuffer buf) throws IOException {
		super.serialize(buf);
	    buf.writeUTF(userId);
	}

	public RplStatusErrMsg(InputBuffer buf, Endpoint endpoint) throws IOException {
		super(buf, endpoint);
	    userId = buf.readUTF();
	}
	
	public String getUserId() {
		return userId;
	}
}
