package toolbox;

import java.util.HashMap;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.Set;

import database.ProfileXMLDB;


public class HealthIndex {
	public static final int INIT_BLOOD = 4; //the value is only for demo
	public static final int INCR_BLOOD = 2;
	
	private ProfileXMLDB profileXMLDB;
	//<userId, health-index>
	private HashMap<String, Integer> healthIndice = new HashMap<String, Integer>();
	
	public HealthIndex(ProfileXMLDB xmldb) {
		profileXMLDB = xmldb;
		profileXMLDB.initHealthIndex(healthIndice);
	}
	
	public long getHealthIndex(String userId) {
		return healthIndice.get(userId);
	}
	
	//reserve: cannot be used by Cuckoo
	public void setHealthIndex(String userId, int index) {
		healthIndice.remove(userId);
		healthIndice.put(userId, index);
	}
	
	public void addHealthIndex(String userId) {
		healthIndice.put(userId, INIT_BLOOD);
	}
	
	public void deleteHealthIndex(String userId) {
		healthIndice.remove(userId);
	}
	
	public void healthIncrease(String userId) {
		Integer hi = healthIndice.remove(userId);
		if(hi != null) {
			hi = hi.intValue()+INCR_BLOOD;
			healthIndice.put(userId, hi);
			if(hi > 10) {
				profileXMLDB.refreshHealthIndex(healthIndice);
			}
		} else { //userId has already dead
			if(profileXMLDB.exist(userId)) {
				healthIndice.put(userId, INCR_BLOOD);
			} else {
				System.out.println("!!!!!!!!!!!!!bullshit, the man's health is none of my business!");
			}
		}
	}
	
	public void healthDecrease(String userId) {
		Integer hi = healthIndice.remove(userId);
		if(hi != null) {
			hi = hi - 1;
			healthIndice.put(userId, hi);
			if(hi == 0) {
				profileXMLDB.refreshHealthIndex(healthIndice);
			} /*else {
				healthIndice.put(userId, hi);
			}*/
		} else {
			System.out.println("the guy does not exist or already die");
		}
	}
	
	public void printHeathIndice() {
		Set<String> keyset = healthIndice.keySet();
		Iterator<String> keyIter = keyset.iterator();
		while(keyIter.hasNext()) {
			String i = keyIter.next();
			int health = healthIndice.get(i);
			System.out.println("key: " + i + ", health: " + health);
		}
	}
	
	/*public Set<String> wrongGetHealthyIds() {
		return healthIndice.keySet();
	}*/
	//Here you must clone a LinkedList or Set to return;
	//Otherwise (like wrongGetHealthyIds()), in Cuckoo main thread will have the concurrency error!
	public LinkedList<String> getHealthyIds() {
		LinkedList<String> result = new LinkedList<String>();
		
		Set<String> keyset= healthIndice.keySet();
		Iterator<String> iterator = keyset.iterator();
		while(iterator.hasNext()) {
			result.addLast(new String(iterator.next()));
		}
		return result;
	}
	
	public void writeBack() {
		profileXMLDB.refreshHealthIndex(healthIndice);
	}
	
	public int getNum() {
		return healthIndice.size();
	}
	
	//For test
	public static void main(String[] args) {
		//Test for Tianyin Xu's profile
		String dir = "xml/0x113601";
		ProfileXMLDB pdb = new ProfileXMLDB(dir, dir + "/followerprofile.xml", "followerprofile");
		//pdb.addNewAttribute("health", HealthIndex.INIT_BLOOD);
		
		//pdb.updateTime("47614300", "12345");
		pdb.xmlParsePrint();
		
		//HealthIndex hi = new HealthIndex(pdb);
		//hi.printHeathIndice();
		
		/*hi.setHealthIndex("27129582", 1);
		hi.hDecrease("27129582");
		hi.hDecrease("27129582");
		hi.hIncrease("27129582");
		pdb.xmlParsePrint();
		hi.printHeathIndice();*/
	}
}
