package toolbox;

import java.util.Date;

import database.TrafficAnalysisXMLDB;

import rice.p2p.commonapi.Message;

public class TrafficAnalysisRecorder {
	private SizeCalculator sizeCalculator = new SizeCalculator();
	private TrafficAnalysisXMLDB trafficXMLDB;
	
	public TrafficAnalysisRecorder(TrafficAnalysisXMLDB db) {
		trafficXMLDB = db;
	}
	
	public void record(Message msg, String type, String io, String fid, String tid, String redt) {
		TrafficLog trafficLog = new TrafficLog(new Date().getTime(), sizeCalculator.calcSize(msg), type, io, fid, tid, redt);
		trafficXMLDB.addTrafficLog(trafficLog);
	}
	
	public void record(long traffic, String type, String io, String fid, String tid, String redt) {
		TrafficLog trafficLog = new TrafficLog(new Date().getTime(), traffic, type, io, fid, tid, redt);
		trafficXMLDB.addTrafficLog(trafficLog);
	}
}
